//
//  IGFlutterEngineManager.m
//  IGame
//
//  Created by junshao on 2019/12/15.
//  Copyright © 2019 Tencent. All rights reserved.
//

#import "FlutterIntegrationManager.h"
#import "FlutterIntegrationViewController.h"

@implementation FlutterIntegrationManager

+(instancetype)sharedInstance{
    static FlutterIntegrationManager *instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[FlutterIntegrationManager alloc] init];
    });
    return instance;
}

-(void)initEngine{
    FlutterEngine *flutterEngine = [[FlutterEngine alloc] initWithName:@"flutterEngine" project:nil];
    [flutterEngine runWithEntrypoint:nil];
    Class clazz = NSClassFromString(@"GeneratedPluginRegistrant");
    if (clazz) {
        if ([clazz respondsToSelector:NSSelectorFromString(@"registerWithRegistry:")]) {
            [clazz performSelector:NSSelectorFromString(@"registerWithRegistry:") withObject:flutterEngine];
        }
    }

    FlutterMethodChannel *methodChannel = [FlutterMethodChannel methodChannelWithName:@"flutter_integration"
                                  binaryMessenger:flutterEngine.binaryMessenger];

    FlutterIntegrationEngineContainer *container = [FlutterIntegrationEngineContainer new];
    container.flutterEngine = flutterEngine;
    container.flutterMethodChannel = methodChannel;

    self.flutterEngineContainer = container;
    
    self.holderVC = [[FlutterIntegrationViewController alloc] initWithEngine:flutterEngine nibName:nil bundle:nil];

    //flutter升级到1.17后，如果holderVC.isViewLoaded属性不为YES，surface仍然会被回收，所以这里强制将holderVC加到window中
    //这行代码可以将self.holderVC.isViewLoaded改为YES
    self.holderVC.view;

    [self registerMethodCallHandler];
}

- (void)registerMethodCallHandler {
    [self.flutterEngineContainer.flutterMethodChannel setMethodCallHandler:^(FlutterMethodCall *call, FlutterResult result) {
        
    }];
}


@end
