//
//  PMDSwizzle.m
//  PMDMobileBase
//
//  Created by Shaunxie on 2019/11/28.
//

#import "FlutterIntegrationSwizzle.h"
#import <objc/runtime.h>

void FlutterIntegrationSwizzleMethod(Class originalCls, SEL originalSelector, Class swizzledCls, SEL swizzledSelector) {
    
    Method originalMethod = class_getInstanceMethod(originalCls, originalSelector);
    Method swizzledMethod = class_getInstanceMethod(swizzledCls, swizzledSelector);
    
    BOOL didAddMethod =
    class_addMethod(originalCls, originalSelector, method_getImplementation(swizzledMethod), method_getTypeEncoding(swizzledMethod));
    
    if (didAddMethod) {
        class_replaceMethod(originalCls, swizzledSelector, method_getImplementation(originalMethod), method_getTypeEncoding(originalMethod));
    } else {
        method_exchangeImplementations(originalMethod, swizzledMethod);
    }
}

void FlutterIntegrationSwizzleClassMethod(Class originalCls, SEL originalSelector, Class swizzledCls, SEL swizzledSelector) {
    FlutterIntegrationSwizzleMethod(object_getClass(originalCls), originalSelector, object_getClass(swizzledCls), swizzledSelector);
}
