import 'package:flutter/services.dart';
import 'package:flutter_integration/Page/integration_page_container.dart';
import 'package:flutter_integration/Tools/IntegrationLogger.dart';
import 'package:flutter_integration/flutter_integration.dart';

class IntegrationNativeChannel {
  final MethodChannel _channel = MethodChannel('flutter_integration');

  IntegrationNativeChannel() {
    _channel.setMethodCallHandler(handleMethodCall);
  }

  Future<void> handleMethodCall(MethodCall methodCall) {
    print('handleMethodCall, method:${methodCall.method}');
    IntegrationPageContainerState container = FlutterIntegration.container;

    if (methodCall.method == "openPage") {
      String routeName = methodCall.arguments['routeName'];
      String pageId = methodCall.arguments['pageId'];
      var params = methodCall.arguments['params'];

      IntegrationLogger.log('open routeName:{$routeName} pageId:{$pageId}');
      container.openPage(routeName, pageId, params);
    } else if (methodCall.method == 'removePage') {
      String pageId = methodCall.arguments['pageId'];

      IntegrationLogger.log('[route] remove pageId:{$pageId}');
      container.removePage(pageId);
    } else {
      throw MissingPluginException("method==${methodCall.method}");
    }

    return null;
  }
}
