import 'package:flutter/material.dart';
import 'package:flutter_integration/Channel/integration_native_channel.dart';
import 'package:flutter_integration/Page/integration_page_container.dart';
import 'package:flutter_integration/Router/integration_router.dart';

class FlutterIntegration {

  static FlutterIntegration _sharedInstance = FlutterIntegration._();
  static FlutterIntegration get sharedInstance => _sharedInstance;
  
  static IntegrationPageContainerState get container => _sharedInstance.containerKey.currentState;
  static IntegrationNativeChannel get channel => _sharedInstance._channel;
  static IntegrationRouter get router {
    return _sharedInstance._pageRouter;
  }
  static set router(IntegrationRouter router) {
    _sharedInstance._pageRouter = router;
  }

  final GlobalKey<IntegrationPageContainerState> containerKey = GlobalKey<IntegrationPageContainerState>();
  final IntegrationNativeChannel _channel = IntegrationNativeChannel();
  IntegrationRouter _pageRouter;

  FlutterIntegration._();

  static TransitionBuilder builder() {
    return (BuildContext context, Widget child) {
      return IntegrationPageContainer(key: _sharedInstance.containerKey);
    };
  }

}
